<?php

/*

*

* copperminevis_SEF - open source sef_ext.php module.

*

* Based on the Docman Sef - open source sef_ext.php module:
	* Copyright (C) 2006 Marko Schmuck aka Predator, webmaster@open-sef.org, http://www.open-sef.org
	* Modified 2006 - Risto Treksler aka irstudio, risto@elkhornbanff.ca
*  Modified 2006 - Kum Sackey aka kes4j, kes4j@virginia.edu

*  Version .8

* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL

* Comments: for Joomla! 1.0.7+ and OpenSEF 2.0.0-RC1+ and Open SEF

*

*/

/** ensure this file is being included by a parent file */

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );



class sef_copperminevis {



	/**

	* Creates the Open SEF URL out of the Joomla! request

	**/

	function create ($string) {

		global $database, $sefConfig, $sufix,$longurl, $CONFIG;

		global $mosConfig_absolute_path, $mosConfig_lang;

		

		if (empty($sefConfig)) {

			$ext_suffix = $sufix;

			$ext_space = _SEF_SPACE;

			$ext_url = $longurl;

		} else {

			$ext_suffix = $sefConfig->encode_page_suffix;

			$ext_space = $sefConfig->encode_space_char;

			$ext_url = $sefConfig->category_title_field;

		}

		$sefstring = '';

		$string = str_replace( '&amp;', '&', $string );
		
		parse_str($string); // create values
							// place: thumbnails, displayimage, gallery, profile
							// cat, albums, pid, pos
							// album: lastcom, toprated
							// page: [int]
							// sort: na, nd, ...
		/*---------------------------------------------------------------------------*/

		// create - translate strings with "task" and "gid" variables

		// task=$var1, gid=$var2

		if (eregi("&place=gallery",$string) 
			&& eregi("&cat=",$string)) {
	
				$sefstring .= copperminevis_catpath($cat);
				if ( eregi("&page=",$string))
					$sefstring .= copperminevis_sefencode('page '.$page);
				else
					$sefstring .= copperminevis_sefencode('page 1'); // default page
				return $sefstring.$ext_suffix;
		} 

		if (eregi("&place=thumbnails",$string) 
			|| eregi("&place=displayimage",$string) 
			&& eregi("&album=",$string)) {
	
		
				if ( is_numeric($album) )
				{
					// Build Bread crumb list
					$result = cpg_db_query("SELECT category, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE `aid` = $album");
					$this_album =  mysql_fetch_assoc($result);
					
					$sefstring .= copperminevis_catpath($this_album['category']); // Show album breadcrumb in url
					$sefstring .= 'albums/'.copperminevis_sefencode($this_album['title']).'/';  // Show album name
				}
				else
				{ // The non-numeric albums are: toprated,lastcom, lastup, topn, lasthits, favpics 
				  // These will never show up in the breadcrumb list 
					$sefstring .= 'albums/'.copperminevis_sefencode($album).'/'; // Show album name
				}
				
				// --- Sorting and Pagination
				if ( eregi("&pos=",$string) )
					$sefstring .= copperminevis_sefencode('pos '.$pos);
				else
				{	
					if ( eregi("&page=",$string))
						$sefstring .= copperminevis_sefencode('page '.$page);
					else
						$sefstring .= copperminevis_sefencode('page 1'); // default page
				}
					
				if ( eregi("&sort=",$string) )
					$sefstring .= copperminevis_sefencode(' sort '.$sort);
				
				return $sefstring.$ext_suffix;
				
		} 


	
		/*---------------------------------------------------------------------------*/
		// As a last resort, simply pass through the url the joomla default URL
								
		$temp = split("\?option=com_copperminevis", $string);
	
		$temp = split('&', $temp[1]);
	
		foreach($temp as $key => $value) {
	
			$sefstring .= $value.'/';
	
		}
	
		$string = str_replace( '=', ',', $sefstring ); 
	
		$string = substr($string, 1);  // Remove the first character of the string because it is not needed
									   // Url: /name,value/name2,value2 ===> name,value/name2/value2
	
		return $string;
		

	}

	

	/**

	* Reverts to the Joomla query string out of the Open SEF URL

	**/

 	function revert ($url_array, $pos) {

		// define all variables you pass as globals

		global $database, $sefConfig, $longurl;

		global $mosConfig_absolute_path, $mosConfig_lang;

		if (empty($sefConfig)) {

			$ext_suffix = $sufix;

			$ext_space = _SEF_SPACE;

			$ext_url = $longurl;

		} else {

			$ext_suffix = $sefConfig->encode_page_suffix;

			$ext_space = $sefConfig->encode_space_char;

			$ext_url = $sefConfig->category_title_field;

		}

		// include language definitions for error messages

		$lang_path = $mosConfig_absolute_path."/language/";

		if (file_exists($lang_path.$mosConfig_lang.".php")) include_once($lang_path.$mosConfig_lang.".php");

		else include_once($lang_path."english.php");

		

		// include language definitions for docman category sorting

		$lang_path = $mosConfig_absolute_path."/components/com_docman/themes/default/language/";

		if (file_exists($lang_path.$mosConfig_lang.".php")) include_once($lang_path.$mosConfig_lang.".php");

		else include_once($lang_path."english.php");

		// Examine the Open SEF URL and extract the variables building the query string

 		$QUERY_STRING = "";

 		$database->setQuery("SELECT id "

		."FROM #__menu "

		."WHERE link='index.php?option=com_copperminevis'");

		$Itemid = $database->loadResult();

		$_GET['Itemid'] = $Itemid;

		$_REQUEST['Itemid'] = $Itemid;

		$QUERY_STRING .= "option=com_copperminevis&Itemid=$Itemid";
		
		$pos = 0;
		
		// Get relative URL to Coppermine directory
		// Include Coppermine init files
		// Disabled for concurrency between modded / unmodded version of copperminevis		
		$database->setQuery("SELECT *FROM #__copperminevis_conf");
		$result = $database->loadObjectList();
		$cpg_conf = $result[0];
		$cpgdir = $mosConfig_absolute_path.'/'.$cpg_conf->cpg_dir; 
			
		//include_once($cpgdir.'include/config.inc.php');
		
		$CONFIG['TABLE_PREFIX'] = 'cpg140_';
		global $table_album, $table_cat;
		$table_album  = $CONFIG['TABLE_PREFIX']."albums";
		$table_cat = $CONFIG['TABLE_PREFIX']."categories";
	
		
		// -- Figure out out which album / category is being pointed at
		if (isset($url_array[$pos+2]) 
		&& $url_array[$pos+2] != "" 
		&& !eregi("Itemid", $url_array[$pos+2])) {
		
			if ( eregi("albums", $url_array[count($url_array)-3]) )  // is the last entry a page item, if yes then this is an album
			{
				// Handle Albums
				// Handle Special Albums
				// The non-numeric albums are: toprated,lastcom, lastup, topn, lasthits, favpics 
				$album = copperminevis_sefdecode($url_array[ count($url_array)-2]);
				if ($album == 'toprated'
					|| $album == 'lastcom'
					|| $album == 'lastup'
					|| $album == 'topn'
					|| $album == 'lasthits'
					|| $album == 'favpics') 
				{
					$aid = $album;
				}
				else
				{
								// Handle Normal Albums
								
					if( count($url_array) > 5) // There's a category and an album tittle
						$aid = copperminevis_get_aid($url_array[ count($url_array)-2 ], $url_array[ count($url_array)- 4 ]);
					else
						$aid = copperminevis_get_aid($url_array[ count($url_array)-2 ]);

				}																									
					
										
				// Handle Pagination
				if ( eregi("page", $url_array[count($url_array)-1]) )
				{
					$temp = explode(" ", copperminevis_sefdecode($url_array[count($url_array)-1])); 
					$_GET['page'] = $_REQUEST['page'] = $temp[1];
					$QUERY_STRING .= "&page=".$temp[1];
				}
				
				// Handle Sort
				if ( eregi("sort", $url_array[count($url_array)-1]) )
				{
					$temp = explode("sort", copperminevis_sefdecode($url_array[count($url_array)-1])); 
					$_GET['sort'] = $_REQUEST['sort'] = $temp[1];
					$QUERY_STRING .= "&sort=".$temp[1];
				}
				
				// Handle Position data for individual pictures
				if ( eregi("pos", $url_array[count($url_array)-1]) )
				{
				
					$_GET['place'] = $_REQUEST['place'] = 'displayimage';		
					$_GET['album'] = $_REQUEST['album'] = $aid;
					$QUERY_STRING .= "&place=displayimage&album=".$aid;
				
					$temp = explode(" ", copperminevis_sefdecode($url_array[count($url_array)-1])); 
					$_GET['pos'] = $_REQUEST['pos'] = $temp[1];
					$QUERY_STRING .= "&pos=".$temp[1];
					
					return $QUERY_STRING;
				}
				
				$_GET['place'] = $_REQUEST['place'] = 'thumbnails';		
				$_GET['album'] = $_REQUEST['album'] = $aid;
				$QUERY_STRING .= "&place=thumbnails&album=".$aid;			
				
				return $QUERY_STRING;	
			}
			else
			{ 
				// Handle Categories
				
				if( count($url_array) > 4) // There are two categories at least
				{ 
					$cid = copperminevis_get_cid($url_array[ count($url_array)-2 ], $url_array[ count($url_array)- 3 ]);
				}
				else
				{
					$cid= copperminevis_get_cid($url_array[ count($url_array)-2 ]);
				}
					
				$_GET['place'] = $_REQUEST['place'] = 'gallery';		
				$_GET['cat'] = $_REQUEST['cat'] = $cid;
				$QUERY_STRING .= "&place=gallery&cat=".$cid;
				
				// Handle Pagination
				if ( eregi("page", $url_array[count($url_array)-1]) )
				{
					$temp = explode(" ", copperminevis_sefdecode($url_array[count($url_array)-1])); 
					$_GET['page'] = $_REQUEST['page'] = $temp[1];
					$QUERY_STRING .= "&page=".$temp[1];
				}				
				
				return $QUERY_STRING;
			}
		}	
		
		
		// --- Pass-through --- 
		// Provides normal Joomla SEF functionality for urls which aren't re-written
		
		if (isset($url_array[$pos+2]) 

		&& $url_array[$pos+2] != "" ) {
			
			for($pos = 3; $pos < count($url_array); $pos++)
			{
				$temp = explode(',', $url_array[$pos]); // explode surely is faster than split, though they do nearly the same thing
				$name = $temp[0];
				$_GET[$name] = $temp[1];
				$_REQUEST[$name] = $temp[1];
				$QUERY_STRING .= '&'.$name.'='.$temp[1];
			}
			
			return $QUERY_STRING;

		}
		
		return $QUERY_STRING;

}


} // end class


/**

 * Get category path for current item

 *

 * @param integer Current category id

 * @return string

 */

function copperminevis_catpath($catid) {

	global $CONFIG;
	
	$catnames = array();

	while ( $catid != 0 ) {

		$result = cpg_db_query("SELECT parent, name FROM {$CONFIG['TABLE_CATEGORIES']} WHERE cid = $catid");
		$category =  mysql_fetch_assoc($result);
		
		//add category names to array to later read in reverse

		array_unshift($catnames, $category['name']);

		$catid = $category['parent'];

	} 

	foreach ( $catnames as $catname ) {

		$tempstring .= copperminevis_sefencode($catname).'/';

	}

	return $tempstring;

}

/**

 * Get a cid based on a string array
 *
 
 * @param string: name of head category, the category we want to find the cid of
 
 * @param string: name of the parent category of the head category
 
 * @return int
 
//  Depth-1 Search algorithm. May return incorrect result if two categories identically named have identically named parents

 */

function copperminevis_get_cid($head, $parent = "") {
	
	global $database, $table_album, $table_cat;
	
	$parent = copperminevis_sefdecode($parent);
	$head = copperminevis_sefdecode($head);
	
	

	if($parent != "")
	{

		$database->setQuery("SELECT parent, cid FROM `$table_cat` WHERE `name` = '$head'");
		$rows_1 = $database->loadObjectList();
		$database->setQuery("SELECT cid FROM `$table_cat` WHERE `name` = '$parent'");
		$rows_2 = $database->loadObjectList();
		
		$cpg_conf = $result[0];

		foreach ($rows_1 as $row_head) {
			foreach ($rows_2 as $row_parent) {
					
				if ($row_head->parent == $row_parent->cid)
					return $row_head->cid;
			}
		}
	}	
	
	
	// Deal with top level categories which have no parent
	$database->setQuery("SELECT cid FROM `$table_cat` WHERE `name` = '$head' AND `parent` = 0 LIMIT 1");
	$rows = $database->loadObjectList();
	if(count($rows) == 1)
	{
		$result = $rows[0];
		return $result->cid;
	}
	
	return 0;
}



/**

 * Get a aid based on a string array
 *
 
 * @param string: name of an album, the album we want to find the aid of
 
 * @param string: name of the parent category of the head category
 
 * @return int
 
//  Depth-1 Search algorithm. May return incorrect result if two categories identically named have identically named parents

 */
 
function copperminevis_get_aid($album_name, $cat_name = "") {

	global $database, $table_album, $table_cat;
	
	$cat_name = copperminevis_sefdecode($cat_name);
	$album_name = copperminevis_sefdecode($album_name);

	if($cat_name != "")
	{
		$database->setQuery("SELECT category, aid FROM `$table_album` WHERE `title` = '$album_name'");
		$rows_1 = $database->loadObjectList();
		$database->setQuery("SELECT cid FROM `$table_cat` WHERE `name` = '$cat_name'");
		$rows_2 = $database->loadObjectList();
		
		$cpg_conf = $result[0];

		foreach ($rows_1 as $row_album) {
			foreach ($rows_2 as $row_cat) {	
				if ($row_album->category == $row_cat->cid)
					return $row_album->aid;
			}
		}
	}	
		
	// Deal with top level categories which have no parent
	$database->setQuery("SELECT aid FROM `$table_album` WHERE `title` = '$album_name' AND `category` = 0 LIMIT 1");
	$rows = $database->loadObjectList();
	if(count($rows) == 1)
	{
		$result = $rows[0];
		return $result->aid;
	}
	
	return 0;
}


/**

 * Get new string with new space filler etc...

 *

 * @param string $string

 * @return encoded string

 */

function copperminevis_sefencode($string) {

	global $sefConfig, $sufix, $lowercase,$url_exception;

	

	if (empty($sefConfig)) {

		$ext_suffix = $sufix;

		$ext_space = _SEF_SPACE;

		$ext_lower = $lowercase;

		$ext_strip = $url_exception;

		foreach ($url_replace as $key => $val) {

			array_push($ext_characters,$key);

			array_push($ext_replacements,$val);

		}

		

	} else {

		$ext_suffix = $sefConfig->encode_page_suffix;

		$ext_space = $sefConfig->encode_space_char;

		$ext_lower = $sefConfig->encode_lowercase;

		$ext_strip = explode(',',$sefConfig->encode_strip_chars);

		$ext_characters = explode(',',$sefConfig->spec_chars_d);

		$ext_replacements = explode(',',$sefConfig->spec_chars);

	}

	

	$string = str_replace($ext_characters,$ext_replacements,$string);

	$string = urlencode($string);

	$string = eregi_replace("%2F", "%10", $string);

	$string = eregi_replace($ext_space, "%11", $string);

	$string = eregi_replace("\+", $ext_space, $string);

	foreach ($ext_strip as $value) {

		$string = ereg_replace(urlencode($value), '', $string);

		//$string = ereg_replace(urlencode($value), $value, $string);

	}

	if ($ext_lower) {

		$string = strtolower($string);

	}

	return $string;

}

/**

 * Get back to original string

 *

 * @param string $string

 * @return decoded string

 */

function copperminevis_sefdecode($string) {

	global $sefConfig, $sufix;

	

	if (empty($sefConfig)) {

		$ext_suffix = $sufix;

		$ext_space = _SEF_SPACE;

		foreach ($url_replace as $key => $val) {

			array_push($ext_characters,$key);

			array_push($ext_replacements,$val);

		}

		

	} else {

		$ext_suffix = $sefConfig->encode_page_suffix;

		$ext_space = $sefConfig->encode_space_char;

		$ext_characters = explode(',',$sefConfig->spec_chars_d);

		$ext_replacements = explode(',',$sefConfig->spec_chars);

	}

	

	$string = eregi_replace($ext_suffix, "", $string);

	$string = eregi_replace($ext_space, "%20", $string);

	$string = eregi_replace("%11", $ext_space, $string);

	$string = eregi_replace("%10", "%2F", $string);

	$string = urldecode($string);

	$string = str_replace($ext_replacements,$ext_characters,$string);

	$string = addslashes($string);

	

	return $string;

}



/**

 * Equivalent of running "copperminevis_sefencode" followed by "copperminevis_sefdecode"

 *

 * @param string $string

 * @return encoded and decoded string

 */

function copperminevis_sefrecode($string) {



	$string = copperminevis_sefencode($string);

	$string = copperminevis_sefdecode($string);

	

	return $string;



}
?>

